
Ruby - Bug #20634

ruby uses 1/2 (7 out of 16) cores for 16 ractors with RUBY_MAX_CPU=16 environment variable set

07/13/2024 09:09 PM - skorobogatydmitry (Dmitry Skorobogaty)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 3.3.1 (2024-04-23 revision

c56cd86388) [x86_64-linux]

Backport: 3.1: UNKNOWN, 3.2: UNKNOWN, 3.3:

UNKNOWN

Description

It's a cont for #20618, feel free to close this one and reopen the original bug.

According to top, the below code uses 7/16 cores (700%) of my AMD Ryzen 7 5800HS:

#!/usr/bin/env ruby

16.times {

  Ractor.new {

    10_000.downto(1) { |i|

      100_000.downto(1) { |j|

        i * j

      }

    }

  }

}

sleep 30

 Command I ran was RUBY_MAX_CPU=16 ruby test.rb. Adding RUBY_MN_THREADS=1 increases CPU usage to 8 cores, possibly

due to N:M for the main Ractor.

The same code occupies all 16 cores on ruby 3.1.2p20 (2022-04-12 revision 4491bb740a) [x86_64-linux]

The problem reproduces on ruby 3.3.3 (2024-06-12 revision f1c7b6f435) [x86_64-linux] (ruby from the latest docker image).

History

#1 - 07/13/2024 09:12 PM - skorobogatydmitry (Dmitry Skorobogaty)

- Description updated

#2 - 07/14/2024 06:38 AM - skorobogatydmitry (Dmitry Skorobogaty)

- Description updated

#3 - 08/09/2024 08:31 AM - skorobogatydmitry (Dmitry Skorobogaty)

I just checked - the problem doesn't repro-es on HEAD (ruby 3.4.0dev (2024-08-09T03:16:23Z master f57167d338) [x86_64-linux])

Could you close it ?

#4 - 08/09/2024 03:35 PM - byroot (Jean Boussier)

- Status changed from Open to Closed
